#!/usr/bin/perl -w

use warnings;
use strict;
use CGI;
use vars qw($INCOMING_DIR $SOURCE);

$INCOMING_DIR = '/home/andrew/lib/www/vidconvert';
$SOURCE       = $ENV{'HTTP_REFERER'} || '';

my $query = new CGI;
my $key   = `pwgen 6 1`; chomp($key);
my $url   = $query->param("url");
my ($ext) = ($query->param("file") || '') =~ /.*(\.\w+)/;

# -- Write out appropriate file...
#
my $lock;
if ($url) {
  $lock = "$key.url.lock";
  system("touch $INCOMING_DIR/$lock");
  open(OUT, ">$INCOMING_DIR/$key.url") or die "Unable to write $key.url: $!\n";
  print OUT $url;
  close(OUT) or die "Unable to close $key.url: $!\n";

} elsif ($ext) {
  $lock = "$key$ext.lock";
  system("touch $INCOMING_DIR/$lock");
  my $upload = $query->upload("file");
  open(OUT, ">$INCOMING_DIR/$key$ext") or die "Unable to write $key$ext: $!\n";
  while (<$upload>) { print OUT }
  close(OUT) or die "Unable to close $key$ext: $!\n";

} else {
  print $query->redirect("$SOURCE?error");
  exit;
}

unlink "$INCOMING_DIR/$lock" if $lock;

my $this  = $ENV{'SCRIPT_NAME'} || '';
my ($dir) = $this =~ /(.*)\//;

sleep 5;
print $query->redirect("$dir/status.cgi?key=$key");
exit;
